﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;

namespace EmbossRibbonTab
{
    public partial class MainForm : Form, IUIElementDrawFilter
    {
        private string strText = "Emboss";
        private Font font = new Font("Mistral", 24);

        public MainForm()
        {
            InitializeComponent();
            this._ultTlbMgr.DrawFilter = this;
            _lblEmboss.Text = string.Empty;
        }

        private void _lblEmboss_Paint(object sender, PaintEventArgs e)
        {
            DoPage(e.Graphics, Color.Black, 150, 35);
        }

        protected void DoPage(Graphics grfx, Color clr, int cx, int cy)
        {
            int iOffset = 3;
            SizeF sizef = grfx.MeasureString(strText, font);
            float x = (cx - sizef.Width) / 2;
            float y = (cy - sizef.Height) / 2;
            for (int i = iOffset; i >= 0; i--)
            {
                grfx.DrawString(strText, font, Brushes.Gray, x - i, y + i);
            }
            grfx.DrawString(strText, font, Brushes.Black, x, y);
        }

        #region IUIElementDrawFilter Members

        bool IUIElementDrawFilter.DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            bool isDrawn = false;
            if (drawParams.Element.Parent is RibbonTabItemUIElement)
            {
                isDrawn = true;
                ImageAndTextUIElement.ImageAndTextDependentTextUIElement element =
                    drawParams.Element as ImageAndTextUIElement.ImageAndTextDependentTextUIElement;
                string strText = element.Text;
                //int cx = element.Rect.Left;
                //int cy = element.Rect.Top;
                //Font font = element.Control.Font;
                int iOffset = 5;
                //SizeF sizef = drawParams.Graphics.MeasureString(strText, font);
                //float x = (cx - sizef.Width) / 2;
                //float y = (cy - sizef.Height) / 2;

                Rectangle rect = new Rectangle(element.Rect.X, element.Rect.Y, element.Rect.Width, element.Rect.Height);

                for (int i = iOffset; i >= 0; i--)
                {
                    rect.X += i;
                    rect.Y += i;
                    drawParams.DrawString(rect, strText, false, false);
                    //drawParams.Graphics.DrawString(strText, font, Brushes.Gray, x - i, y + i);
                }
                drawParams.DrawString(element.Rect, strText, false, false);
                //drawParams.Graphics.DrawString(strText, font, Brushes.Black, x, y);
            }
            return isDrawn;
        }

        DrawPhase IUIElementDrawFilter.GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            Infragistics.Win.DrawPhase drawPhase = DrawPhase.None;
            if (drawParams.Element is ImageAndTextUIElement.ImageAndTextDependentTextUIElement)
            {
                drawPhase = Infragistics.Win.DrawPhase.BeforeDrawForeground;
            }
            return drawPhase;
        }

        #endregion
    }
}
